Lattice Grid Buy a licence

developer guide

Using Lattice Grid with Angular

A standalone component over the same grid every other page runs. You hand the adapter Angular and createGrid; it hands you a component.

Install

The grid and its adapters are one package. The Angular adapter is a separate entry point, so a bundle that never imports it never carries it.

npm i @toclocoinc/lattice-grid

The adapter is a factory

You call createLatticeGrid and hand it your copy of Angular's core namespace and the grid's createGrid, and it returns a standalone component bound to them.

import * as ng from '@angular/core';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

// Build the components once. The adapter takes your Angular and your grid.
const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

The adapter takes no dependency on Angular and carries no second copy of the grid: both are passed in, so there is exactly one Angular and one grid on the page, the versions you installed, and the adapter cannot drift out of step with either. It is a small piece of glue rather than a bundled framework.

One input carries the configuration

Add LatticeGridComponent to a standalone component's imports and drop <lattice-grid> in the template. Its config input is the grid's own configuration, columns and rows and everything else. Change the object and the adapter pushes the change through the grid's public API rather than rebuilding it, so scroll position, selection and open editors survive. Sort, filters, the quick filter and the selected keys each have their own input as well.

@Component({
  selector: 'app-circuits',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="grid" style="display:block;height:520px"></lattice-grid>',
})
export class CircuitsComponent {
  grid = {
    rowKey: 'id',
    columns: [
      { field: 'circuit', title: 'Circuit', layout: { pin: 'start', width: 190 } },
      { field: 'region', title: 'Region', filter: { type: 'set' } },
      { field: 'charge', title: 'Monthly charge', type: 'number',
        format: { style: 'currency', currency: 'GBP' }, total: 'sum' },
    ],
    rows: [/* your rows */],
  };
}

Events are outputs

Every grid event arrives as an Angular output, named with dashes: cell:changed becomes (cell-changed). Bind the ones you need and leave the rest.

@Component({
  selector: 'app-circuits',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="grid" (cell-changed)="onCellChanged($event)"></lattice-grid>',
})
export class CircuitsComponent {
  grid = { rowKey: 'id', columns, rows };
  onCellChanged(e: any) { console.log('changed', e); }
}

Reaching the grid instance

For anything the inputs do not cover, an export, a programmatic filter, a scroll, the component exposes the live grid on a grid getter. Read it with @ViewChild. That is the same object the docs describe everywhere else; the adapter adds nothing to it and hides nothing from it.

import { Component, ViewChild, AfterViewInit } from '@angular/core';

@Component({
  selector: 'app-circuits',
  standalone: true,
  imports: [LatticeGridComponent],
  template: '<lattice-grid [config]="grid"></lattice-grid>',
})
export class CircuitsComponent implements AfterViewInit {
  @ViewChild(LatticeGridComponent) gridRef!: LatticeGridComponent;
  grid = { rowKey: 'id', columns, rows };

  ngAfterViewInit() {
    // gridRef.grid is the real grid instance: the whole public API.
    this.gridRef.grid.export.csv({ download: true });
  }
}

Cleanup on destroy

The adapter destroys the underlying grid when the component is destroyed, releasing its listeners and observers, so there is nothing to clean up by hand.

TypeScript

Type declarations travel with the package, so column and config types are picked up without any tsconfig work. Type your columns and the editor checks them against the grid's own definitions.

import type { GridColumn } from '@toclocoinc/lattice-grid';

const columns: GridColumn[] = [
  { field: 'charge', title: 'Charge', type: 'number', total: 'sum' },
];

One grid per page

Use the Angular adapter or the web component, not both on one page. The web component bundle carries its own copy of the grid, and two copies keep separate registries: a renderer registered through one is invisible to the other. Pick one entry point per page and stay on it.

See also the Angular data grid overview, and the rest of the developer guide.

Lattice Grid Buy a licence

developer guide

Using Lattice Grid with Vue

A Vue 3 component over the same grid. You hand it Vue and createGrid; it hands you a component definition.

Install and build the component

Install @toclocoinc/lattice-grid, then call the adapter factory with your Vue and the grid's createGrid. It returns a Vue 3 component definition.

import * as vue from 'vue';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createLatticeGrid } from '@toclocoinc/lattice-grid/modules/vue';

// A Vue 3 component definition, bound to your Vue and the grid.
const LatticeGrid = createLatticeGrid({ vue, createGrid });

Vue and the grid are passed in rather than imported by the adapter, so it takes no dependency on Vue and carries no second copy of the grid: one Vue, one grid, the versions you installed, and an adapter that cannot disagree with either.

Reactive props and events

Bind :columns and :rows and the grid updates through its public API as they change, keeping scroll, selection and open editors across a re-render rather than rebuilding. Grid events arrive as emits: @cell-changed, @selection-changed and the rest, kebab-cased from the grid's own event names.

<template>
  <LatticeGrid
    row-key="id"
    :columns="columns"
    :rows="rows"
    :style="{ height: '520px' }"
    @cell-changed="onCellChanged"
  />
</template>

<script setup>
const columns = [
  { field: 'circuit', title: 'Circuit', layout: { pin: 'start', width: 190 } },
  { field: 'region', title: 'Region', filter: { type: 'set' } },
  { field: 'charge', title: 'Monthly charge', type: 'number',
    format: { style: 'currency', currency: 'GBP' }, total: 'sum' },
];
</script>

Reaching the grid instance

A template ref exposes .grid, the real instance, for anything the props do not cover.

<LatticeGrid ref="grid" row-key="id" :columns="columns" :rows="rows" />

// grid.value.grid is the real instance: the whole public API.
grid.value.grid.export.csv({ download: true });

Cleanup, and one grid per page

The adapter destroys the grid when the component unmounts, so there is nothing to release by hand. Use the Vue adapter or the web component, not both on one page: the web component carries its own copy of the grid, and two copies keep separate registries.

See also the Vue data grid overview and the developer guide.

Lattice Grid Buy a licence

developer guide

Using Lattice Grid with React

A thin adapter over the same grid every other page runs. You hand it React and createGrid; it hands you a component.

Install

The grid and its adapters are one package. The adapter is a separate entry point, so a bundle that never imports it never carries it.

npm i @toclocoinc/lattice-grid

The adapter is a factory

There is no component to import. You call createLatticeGrid and pass it your copy of React and the grid's createGrid, and it returns a component bound to them.

import React from 'react';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createLatticeGrid } from '@toclocoinc/lattice-grid/modules/react';

// Build the component once, at module scope, not on every render.
const LatticeGrid = createLatticeGrid({ React, createGrid });

This looks like a hoop, and it is the point. The adapter takes no dependency on React and carries no second copy of the grid: both are passed in, so there is exactly one React and one grid on the page, the versions you installed, and the adapter cannot drift out of step with either. It is a few hundred bytes of glue rather than a bundled framework. Build the component once at module scope; calling the factory on every render would rebuild it each time.

Props flow through the public API

The props are the grid's own configuration. Change rows or columns and the adapter pushes the change through the grid's public API rather than tearing the grid down and rebuilding it, so scroll position, selection and open editors survive a re-render. Events the grid emits arrive as on* callbacks.

function Circuits({ rows }) {
  const columns = [
    { field: 'circuit', title: 'Circuit', layout: { pin: 'start', width: 190 } },
    { field: 'region', title: 'Region', filter: { type: 'set' } },
    { field: 'charge', title: 'Monthly charge', type: 'number',
      format: { style: 'currency', currency: 'GBP' }, total: 'sum' },
  ];

  return (
    <LatticeGrid
      rowKey="id"
      columns={columns}
      rows={rows}
      style={{ height: 520 }}
      onCellChanged={(e) => console.log('changed', e)}
    />
  );
}

Reaching the grid instance

For anything the props do not cover, an export, a programmatic filter, a scroll, the component forwards a ref whose .grid is the real instance. That is the same object the docs describe everywhere else; the adapter adds nothing to it and hides nothing from it.

const gridRef = React.useRef(null);

// gridRef.current.grid is the real grid instance: the whole public API.
<LatticeGrid ref={gridRef} rowKey="id" columns={columns} rows={rows} />;

// later, from a button or an effect:
gridRef.current.grid.export.csv({ download: true });

Cleanup on unmount

The adapter destroys the underlying grid when the component unmounts, releasing its listeners and observers, so there is nothing to clean up by hand. Unmount the component and the grid goes with it.

TypeScript

Type declarations travel with the package, so column and config types are picked up without any tsconfig work. Type your columns and the editor checks them against the grid's own definitions.

import type { GridColumn } from '@toclocoinc/lattice-grid';

const columns: GridColumn[] = [
  { field: 'charge', title: 'Charge', type: 'number', total: 'sum' },
];

One grid per page

Use the React adapter or the web component, not both on one page. The web component bundle carries its own copy of the grid, and two copies keep separate registries: a renderer registered through one is invisible to the other. Pick one entry point per page and stay on it.

See also the React data grid overview, and the rest of the developer guide.